Bug 1388385 (CVE-2016-8621)

Summary: CVE-2016-8621 curl: curl_getdate out-of-bounds read
Product: [Other] Security Response Reporter: Andrej Nemec <anemec>
Component: vulnerabilityAssignee: Red Hat Product Security <security-response-team>
Status: CLOSED ERRATA QA Contact:
Severity: low Docs Contact:
Priority: low    
Version: unspecifiedCC: bmcclain, bodavis, cfergeau, csutherl, dbhole, dblechte, eedri, erik-fedora, gzaronik, hhorak, jclere, jorton, kanderso, kdudka, lgao, lsurette, luhliari, mbabacek, mgoldboi, michal.skrivanek, mike, mturk, myarboro, omajid, paul, rh-spice-bugs, rwagner, security-response-team, sherold, srevivo, twalsh, weli, ykaul
Target Milestone: ---Keywords: Security
Target Release: ---   
Hardware: All   
OS: Linux   
Whiteboard:
Fixed In Version: curl 7.51.0 Doc Type: If docs needed, set a value
Doc Text:
Story Points: ---
Clone Of: Environment:
Last Closed: 2019-06-08 03:01:01 UTC Type: ---
Regression: --- Mount Type: ---
Documentation: --- CRM:
Verified Versions: Category: ---
oVirt Team: --- RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: --- Target Upstream Version:
Bug Depends On: 1390894, 1390895, 1390896    
Bug Blocks: 1388393    
Attachments:
Description Flags
Upstream patch none

Description Andrej Nemec 2016-10-25 08:29:11 UTC
The `curl_getdate` converts a given date string into a numerical timestamp and
it supports a range of different formats and possibilites to express a date
and time. The underlying date parsing function is also used internally when
parsing for example HTTP cookies (possibly received from remote servers) and
it can be used when doing conditional HTTP requests.

The date parser function uses the libc sscanf() function at two places, with
the parsing strings "%02d:%02d" and ""%02d:%02d:%02d". The intent being that
it would parse either a string with HH:MM (two digits colon two digits) or
HH:MM:SS (two digits colon two digits colon two digits). If instead the piece
of time that was sent in had the final digit cut off, thus ending with a
single-digit, the date parser code would advance its read pointer one byte too
much and end up reading out of bounds.

External References:

https://curl.haxx.se/docs/adv_20161102G.html

Comment 1 Andrej Nemec 2016-10-25 09:00:20 UTC
Created attachment 1213777 [details]
Upstream patch

Comment 2 Adam Mariš 2016-11-02 08:28:19 UTC
Created curl tracking bugs for this issue:

Affects: fedora-all [bug 1390894]

Comment 3 Adam Mariš 2016-11-02 08:28:34 UTC
Created mingw-curl tracking bugs for this issue:

Affects: fedora-all [bug 1390895]
Affects: epel-7 [bug 1390896]

Comment 6 errata-xmlrpc 2018-08-16 16:07:23 UTC
This issue has been addressed in the following products:

  Red Hat JBoss Core Services

Via RHSA-2018:2486 https://access.redhat.com/errata/RHSA-2018:2486

Comment 7 errata-xmlrpc 2018-11-13 08:33:18 UTC
This issue has been addressed in the following products:

  Red Hat Software Collections for Red Hat Enterprise Linux 6
  Red Hat Software Collections for Red Hat Enterprise Linux 7
  Red Hat Software Collections for Red Hat Enterprise Linux 7.4 EUS
  Red Hat Software Collections for Red Hat Enterprise Linux 7.5 EUS
  Red Hat Software Collections for Red Hat Enterprise Linux 7.6 EUS

Via RHSA-2018:3558 https://access.redhat.com/errata/RHSA-2018:3558